#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
################################################################################
# hold: defines the layout and functions of the select hold types criteria
#	dialog box.
proc hold {} {
  global LABELFONT holdDialogBox activeWindow selv

  busy_cursor
## Bring up the standard Dialog box ##
  set holdDialogBox ".hold"
  set dbox [popupDialogBox $holdDialogBox "Select Hold Type Criteria" 1 "" "" 1]
  set activeWindow($holdDialogBox) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]

## TOP PART ##
  frame $dbox_top.header -height 10m -width 10m
  frame $dbox_top.footer -height 10m -width 10m

  frame $dbox_top.c
  frame $dbox_top.c.val

  pack $dbox_top.c.val
  set chkbox [buildCheckboxes $dbox_top.c.val \
         {{{user user} {other other} {system system}}} grid 5 ""]
  set htypeFrame  [lindex $chkbox 0]
  set htypeUser   [lindex $chkbox 1]
  set htypeOther  [lindex $chkbox 2]
  set htypeSystem [lindex $chkbox 3]

  $htypeUser configure -variable selv(userHoldType) -onvalue u -offvalue ""
  $htypeOther configure -variable selv(userOtherType) -onvalue o -offvalue ""
  $htypeSystem configure -variable selv(userSystemType) -onvalue s -offvalue ""

  set radioList [list   [concat  list \"\" $htypeFrame] \
                          {a "ANY"} ]

  set rbox [buildRadioboxes $dbox_top.c [list $radioList] \
                            column 12 "Hold Types ="]
  set rboxFrame    [lindex $rbox 0]
  set rboxHoldt    [lindex $rbox 1]
  set rboxANY      [lindex $rbox 2]

  $rboxHoldt configure -variable selv(holdt_option) -value holdt -command \
    [list enable_rcbuttons $htypeUser $htypeOther $htypeSystem]

  $rboxANY configure   -variable selv(holdt_option) -value ANY -command \
    [list disable_rcbuttons $htypeUser $htypeOther $htypeSystem]

## SET DEFAULT OPTION ###
  set arg [lindex $selv(hold_list) 1]

  switch -regexp -- $arg {
    "-ANY-" {$rboxANY invoke}
    "u|o|s" {
        $rboxHoldt invoke
	if [regexp "u" $arg] { 
	  set selv(userHoldType) u
	}
	if [regexp "o" $arg] { 
	  set selv(userOtherType) o
	}
	if [regexp "s" $arg] { 
	  set selv(userSystemType) s
	}
    }
  }
## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom \
    {{{ok ok} {help help}}} x 2m 18 3]

  set cmdFrame     [lindex $cmdButtons 0]
  set cmdOk        [lindex $cmdButtons 1]
  set cmdHelp      [lindex $cmdButtons 2]

  $cmdHelp configure -command {xpbs_help select.hold $holdDialogBox}

  $cmdOk configure -command {
    switch -exact -- $selv(holdt_option) {
      holdt {
        set hold_args "$selv(userHoldType)$selv(userOtherType)$selv(userSystemType)"
        if {[string compare $hold_args ""] == 0} {
	  set selv(hold_list) "Hold_Types: n"
         } else {
	  set selv(hold_list) "Hold_Types: $hold_args"
         }
      }
      ANY {set selv(hold_list) "Hold_Types: -ANY-"}
    }
    destroy $holdDialogBox
  }

  register_default_action $holdDialogBox $cmdOk

## PACK the FRAMES
  pack $dbox_top.header $dbox_top.c $dbox_top.footer -padx 10m

  tkwait visibility $holdDialogBox
  remove_busy_cursor
  catch {tkwait window $holdDialogBox}
  set activeWindow($holdDialogBox) 0
}
